# 2024-8-27 ver1
# 在脚本3中生成的warc url可能存在失效问题，此脚本从metadata中提取所有的url（D1、D2），并根据输入返回备用URL
# 首次使用时，必须使用命令行参数/gen准备数据。脚本遍历metadata路径（./output_metadata），在当前目录生成6_get_warc_backup_url.txt
# 查询备用URL时，使用命令行参数/getD2 someurl.txt 输入一个文本文件，每行一个URL，如果在6_get_warc_backup_url.txt中找到这个URL，则返回另一个URL，结果体现在6_D2.txt
# 每次查询的输出都会覆盖6_D2.txt
# 
# 已知问题：

import os  
import json
import re
import sys

input_dir = './output_metadata_all'  

def gen_command(input_file):
    queryurls=[]
    # 将输入文件读入queryurls
    with open(input_file, 'r', encoding='utf-8') as f1:  
        for line in f1:
            queryurls.append(line.strip())
    print(len(queryurls))
    result = []
    # 遍历文件夹中的所有JSON文件  
    for filename in os.listdir(input_dir):  
        if filename.endswith('.json'):  
            json_file_path = os.path.join(input_dir, filename)  
            try:  
                # 读取并解析JSON文件  
                with open(json_file_path, 'r', encoding='utf-8') as f:  
                    data = json.load(f)  
                # 从metadata提取d1和dir属性的值（dl是下载服务器域名，dir是路径）
                d1 = data.get('d1') 
                d2 = data.get('d2') 
                dir_value = data.get('dir')  
                # 检查是否提取到了d1和dir的值  
                if not d1 or not d2 or not dir_value:  
                    print(f"Missing d1 or dir in {filename}")  
                    continue
                # 从meatadata获取所有的files
                files = data.get('files', [])  # 如果JSON中没有'files'键，则默认为空列表
                # 遍历所有的files
                for file_info in files:  
                    name = file_info.get('name')  #文件名
                    urlD1 = 'https://' + d1 + '/' + dir_value + '/' + name
                    urlD2 = 'https://' + d2 + '/' + dir_value + '/' + name
                    for query in queryurls:
                        if query == urlD1:
                            result.append(urlD2)
                        elif query == urlD2:
                            result.append(urlD1)
            except json.JSONDecodeError as e:
                print(f"Error parsing JSON file {filename}: {e}")
            except Exception as e: 
                print(f"Error processing file {filename}: {e}")
    # 将result写入input_file+".changed"
    print(result)
    with open(input_file + ".changed", 'w', encoding='utf-8') as f_result:
        for D2 in result:  
            f_result.write(f"{D2}\n")


def main():
    gen_command(sys.argv[1])

if __name__ == "__main__":
    main()